config_language(): check for existence of /etc/sysconfig/keyboard
[grml-autoconfig.git] / autoconfig.functions
index 44034e7..1364af4 100755 (executable)
@@ -4,7 +4,7 @@
 # Authors:       grml-team (grml.org), (c) Klaus Knopper <knopper@knopper.net>, (c) Michael Prokop <mika@grml.org>
 # Bug-Reports:   see http://grml.org/bugs/
 # License:       This file is licensed under the GPL v2.
-# Latest change: Fre Apr 13 12:49:52 CEST 2007 [mika]
+# Latest change: Mit Sep 05 19:09:45 CEST 2007 [mika]
 ################################################################################
 
 # {{{ path, variables, signals, umask, zsh
@@ -96,7 +96,7 @@ CMDLINE="$(cat /proc/cmdline)"
 
 # {{{ Check if we are running from the grml-CD or HD
 INSTALLED=""
-[ -e /GRML/etc/grml_cd ] || INSTALLED="yes"
+[ -e /etc/grml_cd ] || INSTALLED="yes"
 
 # testcd
 TESTCD=""
@@ -262,10 +262,12 @@ config_language(){
 
    # write keyboard related variables to file for later use
    [ -d /etc/sysconfig ] || mkdir /etc/sysconfig
-   echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
-   echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
-   echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
-   echo "KDEKEYBOARDS=\"$KDEKEYBOARDS\"" >> /etc/sysconfig/keyboard
+   if ! [ -e /etc/sysconfig/keyboard ] ; then
+      echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
+      echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
+      echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
+      echo "KDEKEYBOARDS=\"$KDEKEYBOARDS\"" >> /etc/sysconfig/keyboard
+   fi
  fi
 
  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
@@ -274,19 +276,19 @@ config_language(){
  if [ -r /etc/default/locale ] ; then
     if grep -q "LANG=.*UTF" /etc/default/locale ; then
        if checkgrmlsmall && [ -z "$INSTALLED" ] ; then
-         ewarn "Not runnning unicode_start: grml-small with reduced language support detected." ; eend 0
+          ewarn "Not runnning unicode_start: grml-small with reduced language support detected." ; eend 0
        else
           einfo "Setting up unicode environment."
-          unicode_start ; eend $?
+          unicode_start 2>>$DEBUG ; eend $?
        fi
     fi
  fi
 
  # Set default keyboard before interactive setup
  if [ -n "$KEYTABLE" ] ; then
-  einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
-  loadkeys -q $KEYTABLE &
-  eend $?
+    einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
+    loadkeys -q $KEYTABLE &
+    eend $?
  fi
 
  # we have to set up all consoles, therefore loop it over all ttys:
@@ -444,11 +446,13 @@ update_progress(){
 config_timezone(){
  # don't touch the files if running from harddisk:
  if [ -z "$INSTALLED" ]; then
-  einfo "Setting timezone."
-  KTZ="$(getbootparam tz 2>>$DEBUG)"
-  [ -f "/usr/share/zoneinfo/$KTZ" ] && TZ="$KTZ"
-  rm -f /etc/localtime
-  cp "/usr/share/zoneinfo/$TZ" /etc/localtime && eend 0
+    KTZ="$(getbootparam tz 2>>$DEBUG)"
+    if [ -n "$KTZ" ] ; then
+       einfo "Setting timezone."
+       [ -f "/usr/share/zoneinfo/$KTZ" ] && TZ="$KTZ"
+       rm -f /etc/localtime
+       cp "/usr/share/zoneinfo/$TZ" /etc/localtime ; eend $?
+    fi
  fi
 }
 # }}}
@@ -588,21 +592,33 @@ config_fix_passwd(){
 # {{{ CD Checker
 config_testcd(){
 if [ -n "$TESTCD" ]; then
-  einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
-  einfo "Reading files and checking against GRML/md5sums, this may take a while..."
-  echo -n "${RED}"
-  ( cd /cdrom/GRML/ ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log )
-  if [ "$?" = "0" ]; then
-    echo " ${GREEN}Everything looks OK${NORMAL}"
-    else
-    echo "${RED} *** CHECKSUM FAILED FOR THESE FILES:                          ***"
-    egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
-    echo "${RED} *** DATA ON YOUR CD MEDIUM IS POSSIBLY INCOMPLETE OR DAMAGED, ***${NORMAL}"
-    echo "${RED} *** OR YOUR COMPUTER HAS BAD RAM.                             ***${NORMAL}"
-    echo -n "${CYAN}Hit return to contine, or press the reset button to quit.${NORMAL}\a\a\a "
-    read a
-  fi
-  eend 0
+   einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
+   einfo "Reading files and checking against GRML/md5sums, this may take a while..."
+   echo -n "${RED}"
+
+   # /linuxrc grml version:
+   [ -d /cdrom/GRML ]      && TESTCD_PATH=/cdrom/GRML
+   # live-initramfs version:
+   [ -d /live/image/GRML ] && TESTCD_PATH=/live/image/GRML
+
+   if [ -n "$TESTCD_PATH" ] ; then
+      ( cd "$TESTCD_PATH" ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log )
+   else
+      echo "${RED} *** Error: Could not find md5sum file.                           ***"
+   fi
+
+   if [ "$?" = "0" ]; then
+     echo " ${GREEN}Everything looks OK${NORMAL}"
+     else
+     echo "${RED} *** CHECKSUM FAILED FOR THESE FILES:                          ***"
+     egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
+     echo "${RED} *** DATA ON YOUR CD MEDIUM IS POSSIBLY INCOMPLETE OR DAMAGED, ***${NORMAL}"
+     echo "${RED} *** OR YOUR COMPUTER HAS BAD RAM.                             ***${NORMAL}"
+     echo -n "${CYAN}Hit return to contine, or press the reset button to quit.${NORMAL}"
+     read a
+   fi
+
+   eend 0
 fi
 }
 # }}}
@@ -700,7 +716,7 @@ if checkbootparam "blacklist" ; then
     echo "alias     $BLACK off" >> /etc/modprobe.d/grml
     echo "# end   entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml ; eend $?
   else
-   eerror "No given module for blacklist found. Blacklisting will not work therefor."
+   eerror "No given module for blacklist found. Blacklisting will not work therefore."
   fi
  else
   ewarn "Backlisting via bootoption does not work on harddisk installations." ; eend 1
@@ -716,9 +732,11 @@ fi
 config_acpi_apm(){
 if [ -d /proc/acpi ]; then
   if checkbootparam "noacpi"; then
-    ewarn "Skipping ACPI Bios detection as requested on boot commandline." ; eend 0
+    ewarn "Skipping ACPI Bios detection as requested via noacpi on boot commandline." ; eend 0
+  elif checkbootparam "nogrmlacpi" ; then
+    ewarn "Skipping ACPI Bios detection as requested via nogrmlacpi on boot commandline." ; eend 0
   else
-    einfo "ACPI Bios found, activating modules: "
+    einfo "ACPI Bios found, activating modules (disable via bootoption noacpi / nogrmlacpi): "
     eindent
     found=""
     for a in /lib/modules/$KERNEL/kernel/drivers/acpi/*; do
 config_fstab(){
 
 NOSWAP="yes" # we do not use swap by default!
-if checkbootparam "swap" -o checkbootparam "anyswap" ; then
+if checkbootparam "swap" || checkbootparam "anyswap" ; then
    NOSWAP=''
+   checkbootparam "anyswap" && export ANYSWAP='yes' || export ANYSWAP=""
 fi
 
-if checkbootparam "nofstab" -o checkbootparam "forensic" ; then
+if checkbootparam "nofstab" || checkbootparam "forensic" ; then
   ewarn "Skipping /etc/fstab creation as requested on boot commandline." ; eend 0
 else
-  checkbootparam "anyswap" && export ANYSWAP='yes' || export ANYSWAP=""
   einfo "Scanning for harddisk partitions and creating /etc/fstab. (Disable this via boot option: nofstab)"
   iszsh && setopt nonomatch
   if [ -x /usr/sbin/rebuildfstab ] ; then
-    config_userfstab || fstabuser=grml
-    /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
+     config_userfstab || fstabuser=grml
+     /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
   else
-    ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
+     ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
   fi
-  if [ -e /var/run/rebuildfstab.pid ]; then
-    # Another instance of rebuildfstab, probably from hotplug, is still running, so just wait.
-    sleep 8
-  fi
-fi
-# Scan for swap, config, homedir
-if [ -z "$NOSWAP" ]; then
-   einfo "Searching for swap partition(s) as requested."
-fi
-GRML_IMG=""
-GRML_SWP=""
-HOMEDIR="$(getbootparam home)"
-if [ -n "$partitions" ]; then
- while read p m f relax; do
-  case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
-  partoptions="users,exec"
-  fnew=""
-  case "$f" in swap)
-   eindent
-   if [ -n "$NOSWAP" ]; then
-      if [ -z "$INSTALLED" ] ; then
-         ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)" ; eend 0
-      fi
-   else
-     case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
-             S1SUSP|S2SUSP|pmdisk|[zZ]*)
-                if [ -n "$ANYSWAP" ] ; then
-                  einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
-                  swapon $p 2>>$DEBUG ; eend $?
-                else
-                  ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
-                fi
-               ;;
-             *)
-                if [[ "$p" == LABEL* ]] ; then
-                   p=$(blkid -t $p | awk -F: '{print $1}')
-                fi
-                if grep -q $p /proc/swaps ; then
-                   ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
-                else
-                   einfo "Using swap partition ${WHITE}${p}${NORMAL}."
-                   swapon $p 2>>$DEBUG ; eend $?
-                fi
-               ;;
-     esac
-   fi
-   eoutdent
-   continue
-   ;;
-  esac
-# Create mountdir if not already present, but don't try to create stuff like /proc/bus/usb
-# Notice: grml-rebuildfstab >= 0.3-1 handles this now
-#  case "$m" in *none*|*proc*|*sys*|'') continue ;; esac
-#  [ -d "$m" ] || mkdir -p "$m"
-# WARNING: NTFS RW mounts are only safe since Kernel 2.6.11
-  [ "$f" = "ntfs" -a "${KERNEL%.*}" != "2.6" ] && continue
-  MOUNTOPTS="ro"
-  case "$f" in
-    vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
-    ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
-    *) continue ;;
-    # *) NONEFOUND='1'; continue ;;
-  esac
-  if [ -z "$NOSWAP" ] ; then
-     mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG || continue
-     # Activate swapfile, if exists
-     SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
-  fi
-  if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
-   mount -o remount,rw $m
-   if swapon "$SWAPFILE" 2>>$DEBUG ; then
-    einfo "Using GRML swapfile ${SWAPFILE}."
-    fnew="$SWAPFILE swap swap defaults 0 0"
-    stringinfile "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
-    GRML_SWP="$GRML_SWP $SWAPFILE"
-    eend 0
-   fi
-   mount -o remount,ro $m 2>>$DEBUG
-  fi
-  IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
-  if [ -z "$INSTALLED" -a -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
-   if [ -n "$HOMEDIR" ]; then
-    if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
-     continue
-    fi
-   fi
-   if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
-    GRML_IMG="$IMAGE"
-    mount -o remount,ro $m 2>>$DEBUG
-   fi
-  fi
-  eend 0
-  # Umount, if not in use
-  umount -r $m 2>/dev/null
- done <<EOT
-$(cat /etc/fstab)
+fi # checkbootparam nofstab/forensic
+
+# Scan for swap, config, homedir - but only in live-mode
+if [ -z "$INSTALLED" ] ; then
+   [ -z "$NOSWAP" ] && einfo "Searching for swap partition(s) as requested."
+   GRML_IMG=""
+   GRML_SWP=""
+   HOMEDIR="$(getbootparam home)"
+   if [ -n "$partitions" ]; then
+      while read p m f relax; do
+        case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
+        partoptions="users,exec"
+        fnew=""
+        # it's a swap partition?
+        case "$f" in swap)
+          eindent
+          if [ -n "$NOSWAP" ]; then
+             ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)"
+             eend 0
+          else
+             case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
+                   S1SUSP|S2SUSP|pmdisk|[zZ]*)
+                     if [ -n "$ANYSWAP" ] ; then
+                        einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
+                        swapon $p 2>>$DEBUG ; eend $?
+                     else
+                        ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
+                     fi
+                     ;;
+                   *)
+                     if [[ "$p" == LABEL* ]] ; then
+                        p=$(blkid -t $p | awk -F: '{print $1}')
+                     fi
+                     if grep -q $p /proc/swaps ; then
+                        ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
+                     else
+                        if [ -b "$p" ] ; then
+                        einfo "Using swap partition ${WHITE}${p}${NORMAL}."
+                        swapon $p 2>>$DEBUG ; eend $?
+                        else
+                        ewarn "$p is not a valid block device - not using it therefore." ; eend 0
+                        fi
+                     fi
+                     ;;
+             esac # dd-check
+          fi # -n "$NOSWAP
+          eoutdent
+          continue
+          ;;
+        esac # it's a swap partition?
+
+        # mount read-only
+        MOUNTOPTS="ro"
+        case "$f" in
+          vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
+          ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
+          *) continue ;;
+          # *) NONEFOUND='1'; continue ;;
+        esac
+
+        # use a swapfile
+        if [ -z "$NOSWAP" ] ; then
+           mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG && MOUNTED=1 || continue
+           # Activate swapfile, if exists
+           SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
+        fi
+        if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
+           mount -o remount,rw $m && MOUNTED=1
+           if swapon "$SWAPFILE" 2>>$DEBUG ; then
+              eindent
+                einfo "Using GRML swapfile ${WHITE}${SWAPFILE}${NORMAL}."
+              eoutdent
+              fnew="$SWAPFILE swap swap defaults 0 0"
+              stringinfile "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
+              GRML_SWP="$GRML_SWP $SWAPFILE"
+              eend 0
+           fi
+           mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
+        fi
+
+        # use a image as home
+        IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
+        if [ -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
+           if [ -n "$HOMEDIR" ]; then
+              if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
+                 continue
+              fi
+           fi
+           if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
+              GRML_IMG="$IMAGE"
+              mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
+           fi
+        fi
+        eend 0
+
+        # Umount, if not in use
+        [ -n "$MOUNTED" ] && umount -r $m 2>/dev/null
+
+      done <<EOT
+      $(cat /etc/fstab)
 EOT
-fi
+   fi # -n $partitions
+fi # -z $INSTALLED
 }
 # }}}
 
@@ -1164,6 +1187,10 @@ else
     sleep 1
     eend 0
   done
+  if [ -n "$INSTALLED" ] ; then
+     ewarn 'If you want to disable automatic DHCP requests set CONFIG_DHCP=no in /etc/grml/autoconfig.'
+     eend 0
+  fi
 fi
 }
 # }}}
@@ -1244,28 +1271,78 @@ else
      einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
   fi
 
+  # Disclaimer: sorry for the tons of if/then/else... but this makes sure we use:
+  # * it only if we have the according kernel modules available
+  # * cpufreq only on laptops (check via /usr/sbin/laptop-detect) and not inside Virtual Box
+  # * current version of /etc/init.d/loadcpufreq from Debian (to stay in sync)
+  #   -> parse output of the initscript and output it according to our look'n'feel
+  # * our own cpufreq-detect.sh if /etc/init.d/loadcpufreq isn't present
   if ! cpufreq_check ; then
     ewarn "Skipping cpufreq setup as module dependencies are not fulfilled." ; eend 1
   else
-    if /usr/sbin/laptop-detect ; then
+    if /usr/sbin/laptop-detect 1>/dev/null 2>&1 ; then
+       # Virtual Box supports ACPI and laptop-detect returns with '0', so check for it:
+       if [ -r /proc/acpi/battery/BAT0/info ] ; then
+          if grep -q 'OEM info:                innotek' /proc/acpi/battery/BAT0/info ; then
+             einfo 'Virtual Box detected, skipping cpufreq setup.' ; eend 0
+             return 0
+          fi
+       fi
        einfo "Detected Laptop - trying to use cpu frequency scaling:"
-       if [ -r /usr/bin/cpufreq-detect.sh ] ; then
-          eindent
+       eindent
+       if [ -x /etc/init.d/loadcpufreq ] ; then
+          SKIP_CPU_GOVERNOR=''
+          LOADCPUFREQ=$(mktemp)
+          /etc/init.d/loadcpufreq start >"$LOADCPUFREQ" 2>&1 ; RC=$?
+          if grep -q FATAL "$LOADCPUFREQ" ; then
+             eindent
+               SKIP_CPU_GOVERNOR=1
+               oldIFS="$IFS"
+               IFS="
+"
+                for line in $(grep FATAL "$LOADCPUFREQ" | sed 's/.*FATAL: //; s/ (.*)//') ; do
+                    eerror "$line" ; eend $RC
+                done
+                IFS="$oldIFS"
+             eoutdent
+           elif grep -q done "$LOADCPUFREQ" ; then
+             MODULE=$(grep done "$LOADCPUFREQ" | sed 's/.*done (\(.*\))./\1/')
+             if [ -n "$MODULE" -a "$MODULE" != none ]; then
+                einfo "Loading cpufreq kernel module $MODULE" ; eend 0
+             else
+                ewarn "Could not find an appropriate kernel module for cpu frequency scaling." ; eend 1
+             fi
+          fi
+          rm -f $LOADCPUFREQ
+       elif [ -r /usr/bin/cpufreq-detect.sh ] ; then
           . /usr/bin/cpufreq-detect.sh
           if [ -n "$MODULE" -a "$MODULE" != none ]; then
-             einfo "Loading modules ${MODULE} and cpufreq_ondemand, setting ondemand governor"
+             einfo "Loading modules ${MODULE}"
              modprobe "$MODULE" 1>>$DEBUG || modprobe "$MODULE_FALLBACK" 1>>$DEBUG
-             if modprobe cpufreq_ondemand && RC=0 || RC=1 ; then
-                for file in $(find /sys/devices/system/cpu/ -name scaling_governor 2>/dev/null) ; do
-                    echo ondemand > $file
-                done
+             RC=$?
+             if [[ $RC == 0 ]]; then
+                eend 0
+             else
+                SKIP_CPU_GOVERNOR=1
+                eend $1
              fi
-             eend $RC
           else
              ewarn "Could not detect an appropriate CPU for use with cpu frequency scaling - skipping." && eend 1
+          fi # $MODULE
+       fi # loadcpufreq
+
+       if [ -z "$SKIP_CPU_GOVERNOR" ] ; then
+          einfo "Loading cpufreq_ondemand, setting ondemand governor"
+          if modprobe cpufreq_ondemand ; RC=$? ; then
+             for file in $(find /sys/devices/system/cpu/ -name scaling_governor 2>/dev/null) ; do
+                 echo ondemand > $file
+             done
           fi
-          eoutdent
-       fi # cpufreq-detect
+          eend $RC
+       fi # cpu-governor
+
+       eoutdent
+
     fi # laptop-detect
   fi # cpufreq_check
 fi # checkbootparam nocpu
@@ -1313,79 +1390,83 @@ fi
 # {{{ Check for persistent homedir option and eventually mount /home from there, or use a loopback file.
 config_homedir(){
 if checkbootparam home ; then
-HOMEDIR="$(getbootparam home)"
-MYHOMEDEVICE=""
-MYHOMEMOUNTPOINT=""
-MYHOMEDIR=""
-if [ -n "$HOMEDIR" ]; then
-  einfo "Bootoption home detected." && eend 0
-  case "$HOMEDIR" in
-    /dev/*)
-    MYHOMEDEVICE="${HOMEDIR##/dev/}"
-    MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
-    MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
-    MYHOMEDIR="/mnt/${HOMEDIR##/dev/}"
-  ;;
-    /mnt/*)
-    MYHOMEDEVICE="${HOMEDIR##/mnt/}"
-    MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
-    MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
-    MYHOMEDIR="$HOMEDIR"
-  ;;
-    [Aa][Uu][Tt][Oo]|[Ss][Cc][Aa][Nn]|[Ff][Ii][Nn][Dd])
-    MYHOMEDIR="$(findfile grml.img)"
-    MYHOMEDEVICE="${MYHOMEDIR##/mnt/}"
-    MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
-    MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
-  ;;
-  *)
-    eerror "Invalid home= option '$HOMEDIR' specified (must start with /dev/ or /mnt/ or 'scan')." ; eend 1
-    eerror "Option ignored." ; eend 1
-  ;;
-  esac
-fi
-
-if [ -n "$MYHOMEDIR" ]; then
-  if trymount "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"; then
-    [ -f "$MYHOMEMOUNTPOINT/grml.img" ] && MYHOMEDIR="$MYHOMEMOUNTPOINT/grml.img"
-    while read device mountpoint fs relax; do
-      case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
-        case "$fs" in *[Nn][Tt][Ff][Ss]*)
-          umount "$MYHOMEMOUNTPOINT"; eerror "Error: will not mount NTFS filesystem on $MYHOMEDEVICE read/write!" ; eend 1
-          break
-        ;;
-        *[Ff][Aa][Tt]*)
-        # Note: This currently won't work with encrypted partitions
-        umount "$MYHOMEMOUNTPOINT"; mount -t vfat -o rw,uid=grml,gid=grml,umask=002 "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"
-        if [ ! -f "$MYHOMEDIR" ]; then
-          ewarn "WARNING: FAT32 is not a good filesystem option for /home/grml (missing socket/symlink support)."
-          ewarn "WARNING: Better use an ext2 loopback file on this device, and boot with home=$MYHOMEDEVICE/grml.img."
-        fi
-        ;;
-      esac
-      if mount -o remount,rw "$MYHOMEMOUNTPOINT"; then
-        einfo "Mounting ${WHITE}$MYHOMEDIR${NORMAL} as ${WHITE}/home/grml${NORMAL}."
-        if [ -f "$MYHOMEDIR" ]; then
-          # It's a loopback file, mount it over the /home/grml directory
-          trymount "$MYHOMEDIR" /home/grml
-          RC="$?"
-          [ "$RC" = "0" ] && ERROR="$(mount -o remount,rw /home/grml 2>&1)"
-          RC="$?"
-        else
-          # Do a --bind mount
-          ERROR="$(mount --bind "$MYHOMEDIR" /home/grml 2>&1)"
-          RC="$?"
-        fi
-        [ "$RC" = "0" ] && eend 0 || ( eerror "${ERROR}" ; eend 1 )
-      fi
-      break
+   HOMEDIR="$(getbootparam home)"
+   MYHOMEDEVICE=""
+   MYHOMEMOUNTPOINT=""
+   MYHOMEDIR=""
+   if [ -n "$HOMEDIR" ]; then
+      einfo "Bootoption home detected." && eend 0
+      case "$HOMEDIR" in
+        /dev/*)
+        MYHOMEDEVICE="${HOMEDIR##/dev/}"
+        MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
+        MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
+        MYHOMEDIR="/mnt/${HOMEDIR##/dev/}"
+      ;;
+        /mnt/*)
+        MYHOMEDEVICE="${HOMEDIR##/mnt/}"
+        MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
+        MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
+        MYHOMEDIR="$HOMEDIR"
+      ;;
+        [Aa][Uu][Tt][Oo]|[Ss][Cc][Aa][Nn]|[Ff][Ii][Nn][Dd])
+        MYHOMEDIR="$(findfile grml.img)"
+        MYHOMEDEVICE="${MYHOMEDIR##/mnt/}"
+        MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
+        MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
       ;;
-    esac
-  done <<EOT
-$(cat /proc/mounts)
+      *)
+        eerror "Invalid home= option '$HOMEDIR' specified (must start with /dev/ or /mnt/ or 'scan')." ; eend 1
+        eerror "Option ignored." ; eend 1
+      ;;
+      esac
+   fi # -n $HOMEDIR
+
+   if [ -n "$MYHOMEDIR" ]; then
+      if trymount "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"; then
+         [ -f "$MYHOMEMOUNTPOINT/grml.img" ] && MYHOMEDIR="$MYHOMEMOUNTPOINT/grml.img"
+         while read device mountpoint fs relax; do
+           case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
+             case "$fs" in
+               *[Nn][Tt][Ff][Ss]*)
+                 umount "$MYHOMEMOUNTPOINT"; eerror "Error: will not mount NTFS filesystem on $MYHOMEDEVICE read/write!" ; eend 1
+                 break
+                 ;;
+               *[Ff][Aa][Tt]*)
+                 # Note: This currently won't work with encrypted partitions
+                 umount "$MYHOMEMOUNTPOINT"; mount -t vfat -o rw,uid=grml,gid=grml,umask=002 "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"
+                 if [ ! -f "$MYHOMEDIR" ]; then
+                    ewarn "WARNING: FAT32 is not a good filesystem option for /home/grml (missing socket/symlink support)."
+                    ewarn "WARNING: Better use an ext2 loopback file on this device, and boot with home=$MYHOMEDEVICE/grml.img."
+                 fi
+                 ;;
+             esac
+
+             if mount -o remount,rw "$MYHOMEMOUNTPOINT"; then
+                einfo "Mounting ${WHITE}$MYHOMEDIR${NORMAL} as ${WHITE}/home/grml${NORMAL}."
+                if [ -f "$MYHOMEDIR" ]; then
+                   # It's a loopback file, mount it over the /home/grml directory
+                   trymount "$MYHOMEDIR" /home/grml
+                   RC="$?"
+                   [ "$RC" = "0" ] && ERROR="$(mount -o remount,rw /home/grml 2>&1)"
+                   RC="$?"
+                else
+                   # Do a --bind mount
+                   ERROR="$(mount --bind "$MYHOMEDIR" /home/grml 2>&1)"
+                   RC="$?"
+                fi # -f $MYHOMEDIR
+
+                [ "$RC" = "0" ] && eend 0 || ( eerror "${ERROR}" ; eend 1 )
+
+             fi #  mount -o remount,rw,...
+           break
+           ;;
+           esac # case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
+         done <<EOT
+         $(cat /proc/mounts)
 EOT
-  fi
-fi
+     fi # if trymount ...
+   fi # -n $MYHOMEDIR
 fi # checkbootparam home
 }
 # }}}
@@ -1407,6 +1488,11 @@ if ! [ -x /usr/bin/aumix ] ; then
   eerror "aumix binary not available. Can not set sound volumes therefore." ; eend 1
 else
 
+  if ! [ -r /proc/asound/cards ] ; then
+     ewarn "No soundcard present, skipping mixer settings therefore." ; eend 0
+     return
+  fi
+
   if checkbootparam vol ; then
     VOL="$(getbootparam 'vol' 2>>$DEBUG)"
     if [ -z "$VOL" ] ; then
@@ -1445,7 +1531,7 @@ else
       ERROR=$(aumix -w $VOL -v $VOL -p $VOL -m $VOL 2>&1) ; RC=$?
       if [ -n "$ERROR" ] ; then
          eindent
-         eerror "Problem setting mixer volumes: $ERROR"
+         eerror "Problem setting mixer volumes: $ERROR (no soundcard?)"
          eoutdent
       fi
       eend $RC
@@ -1461,11 +1547,10 @@ if checkbootparam "nomodem"; then
   ewarn "Skipping check for AC97 modem controller as requested on boot commandline." ; eend 0
 else
   if [ -x /etc/init.d/sl-modem-daemon ] ; then
-   if lspci | grep Intel | grep -q "AC'97 Modem Controller" ; then
-     einfo "AC97 modem controller detected. Starting sl-modem-daemon in background."
-     /etc/init.d/sl-modem-daemon start >>$DEBUG &
-     eend 0
-   fi
+     if lspci | grep Intel | grep -q "AC'97 Modem Controller" ; then
+        einfo "AC97 modem controller detected. Start it running 'Start sl-modem-daemon'."
+        eend 0
+     fi
   fi
 fi
 }
@@ -1653,7 +1738,12 @@ sudo -u $fstabuser -i /usr/bin/grml-x $WINDOWMANAGER 1>>$DEBUG
 EOF
    chmod 755 /etc/init.d/xstartup
 
-   sed -i 's#^6:.*#6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"#' /etc/inittab
+   # adjust inittab for xstartup
+   if grep -q '^6:' /etc/inittab ; then
+      sed -i 's|^6:.*|6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"|' /etc/inittab
+   else # just append tty6 to inittab if no definition is present:
+      echo '6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"' >> /etc/inittab
+   fi
 
    /sbin/telinit q ; eend $?
 
@@ -1684,7 +1774,7 @@ fi
 }
 
 config_automount(){
-if checkbootparam noautoconfig -o checkbootparam forensic ; then
+if checkbootparam noautoconfig || checkbootparam forensic ; then
   ewarn "Skipping running automount of device(s) labeled GRMLCFG as requested." ; eend 0
 else
  if [ -z "$INSTALLED" ] ; then
@@ -1965,8 +2055,8 @@ fi
 config_swraid(){
   if [ -z "$INSTALLED" ] ; then
   # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
-  if checkbootparam 'noraid'   -o checkbootparam 'noswraid' -o \
-     checkbootparam 'forensic' -o checkbootparam 'raid=noautodetect' ; then
+  if checkbootparam 'noraid'   || checkbootparam 'noswraid' -o \
+     checkbootparam 'forensic' || checkbootparam 'raid=noautodetect' ; then
      ewarn "Skipping SW-RAID code as requested on boot commandline." ; eend 0
   else
     if ! [ -x /sbin/mdadm ] ; then
@@ -2030,6 +2120,33 @@ config_swraid(){
 }
 # }}}
 
+# {{{ LVM (Logical Volumes)
+config_lvm(){
+  if [ -z "$INSTALLED" ] ; then
+  # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
+  if checkbootparam 'nolvm' ; then
+     ewarn "Skipping LVM code as requested on boot commandline." ; eend 0
+  else
+    if ! [ -x /sbin/lvm -a -x /etc/init.d/lvm2 -a -x /sbin/lvdisplay ] ; then
+       eerror "LVM not available, can not execute it." ; eend 1
+    else
+       if lvdisplay 2>&1 | grep -v 'No volume groups found' 1>/dev/null 2>&1 ; then
+          einfo "You seem to have logical volumes (LVM) on your system."
+          eindent
+          einfo "Just run 'Start lvm2' to activate them or boot using 'lvm' as bootoption for autostart."
+          eend 0
+          if checkbootparam 'lvm' ; then
+             einfo "Bootoption LVM found. Searching for logical volumes:"
+             /etc/init.d/lvm2 start ; eend $?
+          fi
+          eoutdent
+       fi
+    fi # check for lvm binary
+  fi # check for bootoption nolvm
+  fi # run only in live-cd mode
+}
+# }}}
+
 # {{{ debnet: setup network based on an existing one found on a partition
 config_debnet(){
 if checkbootparam "debnet" ; then
@@ -2076,6 +2193,19 @@ fi
 }
 # }}}
 
+# {{{ check for broken ipw3945 driver which causes problems (especially on hd install)
+config_ipw3945() {
+  if grep -q ipw3945 /proc/modules ; then
+     if ! iwconfig 2>/dev/null| grep -qe 'IEEE 802' -qe 'unassociated' ; then
+        ewarn "Broken ipw3945 network interface found, reloading module."
+        rmmod ipw3945
+        modprobe ipw3945
+        eend $?
+     fi
+  fi
+}
+# }}}
+
 # {{{ disable console blanking
 config_blanking(){
 if checkbootparam "noblank" ; then
 # {{{ grml2hd: automatic installation
 config_grml2hd(){
 
+if stringinstring "BOOT_IMAGE=grml2hd " "$CMDLINE" ; then
+
 if checkbootparam "user" ; then
-  NEWUSER=''
-  NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
-  sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
+   NEWUSER=''
+   NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
+   sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
 fi
 
 if checkbootparam "filesystem" ; then
-  FILESYSTEM=''
-  FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
-  sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
+   FILESYSTEM=''
+   FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
+   sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
 fi
 
 if checkbootparam "partition" ; then
-  PARTITION=''
-  PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
-  # notice: the following checks whether the given partition is available, if not the skip
-  # execution of grml2hd as it might result in data loss...
-  if [ -r $PARTITION ] ; then
-    sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
-  else
-    ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
-  fi
+   PARTITION=''
+   PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
+   # notice: the following checks whether the given partition is available, if not the skip
+   # execution of grml2hd as it might result in data loss...
+   if [ -r $PARTITION ] ; then
+      sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
+   else
+      ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
+   fi
 fi
 
 if checkbootparam "mbr" ; then
-  BOOT_PARTITION=''
-  BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
-  sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
+   BOOT_PARTITION=''
+   BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
+   sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
 fi
 
-if stringinstring "BOOT_IMAGE=grml2hd " "$CMDLINE" ; then
-  cat>|/usr/bin/grml2hd_noninteractive<<EOF
+cat>|/usr/bin/grml2hd_noninteractive<<EOF
 #!/bin/sh
 GRML2HD_NONINTERACTIVE='yes' grml2hd
 EOF
-  chmod 755 /usr/bin/grml2hd_noninteractive
-  einfo "Bootparameter grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
-  if [ -z "$GRML2HD_FAIL" ] ; then
-    screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
-  else
-    ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
+
+chmod 755 /usr/bin/grml2hd_noninteractive
+einfo "Bootoption grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
+if [ -z "$GRML2HD_FAIL" ] ; then
+   screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
+else
+   ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
+fi
+
+fi # if stringinstring "BOOT_IMAGE=grml2hd ...
+}
+# }}}
+
+# {{{ debootstrap: automatic installation
+config_debootstrap(){
+
+if stringinstring "BOOT_IMAGE=debian2hd " "$CMDLINE" ; then
+
+einfo "Bootoption debian2hd found. Setting up environment for automatic installation via grml-debootstrap." ; eend 0
+
+if ! [ -x /usr/sbin/grml-debootstrap ] ; then
+   eindent
+   eerror "Bootoption debian2hd found, but grml-debootstrap is not available." ; eend 1
+   eoutdent
+   exit 1
+fi
+
+if checkbootparam "target" ; then
+  TARGET=''
+  TARGET="$(getbootparam 'target' 2>>$DEBUG)"
+  # notice: the following checks whether the given partition is available, if not the skip
+  # execution of grml-debootstrap as it might result in data loss...
+  if ! [ -r "$TARGET" ] ; then
+     eerror "Target $TARGET does not exist. Skipping execution of grml-debootstrap therefore." ; eend 1
   fi
+else
+  eindent
+  eerror "No bootoption named target found, can not continue execution of grml-debootstrap." ; eend 1
+  eoutdent
+  exit 1
+fi
+
+if checkbootparam "grub" ; then
+  GRUB=''
+  GRUB="$(getbootparam 'grub' 2>>$DEBUG)"
+fi
+
+if checkbootparam "groot" ; then
+  GROOT=''
+  GROOT="$(getbootparam 'groot' 2>>$DEBUG)"
 fi
+
+if checkbootparam "release" ; then
+  RELEASE=''
+  RELEASE="$(getbootparam 'release' 2>>$DEBUG)"
+fi
+
+if checkbootparam "mirror" ; then
+  MIRROR=''
+  MIRROR="$(getbootparam 'mirror' 2>>$DEBUG)"
+fi
+
+if checkbootparam "boot_append" ; then
+  BOOT_APPEND=''
+  BOOT_APPEND="$(getbootparam 'boot_append' 2>>$DEBUG)"
+fi
+
+if checkbootparam "password" ; then
+  PASSWORD=''
+  PASSWORD="$(getbootparam 'password' 2>>$DEBUG)"
+fi
+
+# now check which options are available
+if [ -n "TARGET" ] ; then
+   TARGETCMD="--target $TARGET"
+else
+   TARGETCMD=''
+   eindent
+   eerror "Target not set via bootoption. Skipping execution of grml-debootstrap therefore."; eend 1
+   eoutdent
+   exit 1
+fi
+[ -n "$GRUB" ]     && GRUBCMD="--grub $GRUB"               || GRUBCMD=''
+[ -n "$GROOT" ]    && GROOTCMD="--groot $GROOT"            || GROOTCMD=''
+[ -n "$RELEASE" ]  && RELEASECMD="--release $RELEASE"      || RELEASECMD=''
+[ -n "$MIRROR" ]   && MIRRORCMD="--mirror $MIRROR"         || MIRRORCMD=''
+[ -n "$PASSWORD" ] && PASSWORDCMD="--password $PASSWORD"   || PASSWORDCMD=''
+[ -n "$BOOT_APPEND" ] && BOOT_APPEND="--boot_append $BOOT_APPEND" || BOOT_APPEND=''
+
+# and finally write script and execute it
+cat>|/usr/bin/grml-debootstrap_noninteractive<<EOF
+#!/bin/sh
+AUTOINSTALL='yes' grml-debootstrap $TARGETCMD $GRUBCMD $GROOTCMD $RELEASECMD $MIRRORCMD $PASSWORDCMD $BOOT_APPEND
+EOF
+
+chmod 750  /usr/bin/grml-debootstrap_noninteractive
+
+screen /usr/bin/grml-debootstrap_noninteractive
+einfo "Invoking a shell, just exit to continue booting..."
+/bin/zsh
+
+fi # stringinstring "BOOT_IMAGE=debian2hd
 }
 # }}}
 
@@ -2140,6 +2365,8 @@ if checkbootparam "distri"; then
   DISTRI="$(getbootparam 'distri' 2>>$DEBUG)"
   if [ -r /cdrom/desktop/"$DISTRI".jpg ] ; then
      [ -n "$BOOTDEBUG" ] && einfo "Debug: bootoption distri found and file /cdrom/desktop/$DISTRI present" && eend 0
+     # make sure the desktop.jpg file is not a symlink, so copying does not file then
+     [ -L /usr/share/grml/desktop.jpg ] && rm /usr/share/grml/desktop.jpg
      cp /cdrom/desktop/"$DISTRI".jpg /usr/share/grml/desktop.jpg
   fi
 fi
@@ -2156,4 +2383,4 @@ config_keyboard(){
 # }}}
 
 ## END OF FILE #################################################################
-# vim:foldmethod=marker
+# vim:foldmethod=marker expandtab ai ft=zsh shiftwidth=3